unit MainU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Spin, DateUtils,
  HelligdageU;

type
  TStringsHelper = class helper for TStrings
  private
    function GetCountryLocale(Index: Integer): TCountryLocale;
    procedure SetCountryLocale(Index: Integer; const Value: TCountryLocale);
  public
    function AddCountryLocale(const Value: String; const CountryLocale: TCountryLocale): Integer;
    property CountryLocale[Index: Integer]: TCountryLocale read GetCountryLocale write SetCountryLocale;
  end;

  TMainForm = class(TForm)
    ListBox1: TListBox;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    btnNative: TButton;
    btnEnglish: TButton;
    btnList: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnNativeClick(Sender: TObject);
    procedure btnEnglishClick(Sender: TObject);
    procedure btnListClick(Sender: TObject);
  private
    function GetStdDato : TStdDato;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.btnNativeClick(Sender: TObject);
var
  STDDato: TStdDato;
  aName: string;
begin
  STDDato := GetStdDato;
  ListBox1.Clear;

  for aName in STDDato.NativeNames do
    ListBox1.Items.Add(aName);

  FreeAndNil(STDDato);
end;

procedure TMainForm.btnEnglishClick(Sender: TObject);
var
  STDDato: TStdDato;
  aName: string;
begin
  STDDato := GetStdDato;

  ListBox1.Clear;
  for aName in STDDato.EnglishNames do
    ListBox1.Items.Add(aName);

  FreeAndNil(STDDato);
end;

procedure TMainForm.btnListClick(Sender: TObject);
var
  STDDato: TStdDato;
  HolyDay: THoliDay;
begin
  STDDato := GetStdDato;

  ListBox1.Clear;
  for HolyDay in STDDato do
    ListBox1.Items.Add(HolyDay.DateAsStr + #32 + HolyDay.NativeName);

  FreeAndNil(STDDato);
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  CountryLocale: TCountryLocale;
begin
  SpinEdit1.Value := YearOf(now);

  for CountryLocale := low(TCountryLocale) to High(TCountryLocale) do
    ComboBox1.Items.AddCountryLocale(CountryLocaleString[CountryLocale], CountryLocale);

  ComboBox1.ItemIndex := 0;
end;

function TMainForm.GetStdDato: TStdDato;
begin
  Result := TStdDato.Create;
  Result.Year := SpinEdit1.Value;
  Result.Country := ComboBox1.Items.CountryLocale[ComboBox1.ItemIndex];
  Result.MarkSunday := false;
  Result.MakeHoliDays(0); // refresh list
end;

{ TStringsHelper }

function TStringsHelper.AddCountryLocale(const Value: String; const CountryLocale: TCountryLocale): Integer;
begin
  Result := AddObject(CountryLocaleString[CountryLocale], TObject(Integer(CountryLocale)));
end;

function TStringsHelper.GetCountryLocale(Index: Integer): TCountryLocale;
begin
  Result := TCountryLocale(Integer(Objects[Index]));
end;

procedure TStringsHelper.SetCountryLocale(Index: Integer; const Value: TCountryLocale);
begin
  Objects[Index] := TObject(Integer(Value))

end;

end.
